<?php
/*
Plugin Name: Ads-WordPress
Plugin URI: http://ili.com.ua/wordpress/ads-wordpress
Description: Ads for WordPress
Author: Yuriy Stepanov (stur)
Version: 3.1.0
Author URI: http://ili.com.ua/wordpress/
*/

/*  Copyright 2010  Stepanov Yuri (stur)(email: y.stepanov@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the  Creative Commons (BY-SA) License
        BY: This license lets others distribute, remix, tweak, and build
    upon your work, even commercially, as long as they credit you for the
    original creation. This is the most accommodating of licenses offered,
    in terms of what others can do with your works licensed under Attribution.
        SA: This license lets others remix, tweak, and build upon your work
    even for commercial reasons, as long as they credit you and license their
    new creations under the identical terms. This license is often compared
    to open source software licenses. All new works based on yours will carry
    the same license, so any derivatives will also allow commercial use.

*/

// global unit
require_once "ads_init.php";
@include_once "ads_config.php";  // user config file

//  cron
register_activation_hook(__FILE__, 'ads_activation');
function ads_activation() {
	wp_schedule_event(time(), 'hourly', 'ads_hourly_event');
}
register_deactivation_hook(__FILE__, 'ads_deactivation');
function ads_deactivation() {
	wp_clear_scheduled_hook('ads_hourly_event');
}
/* cron */
add_action('ads_hourly_event', 'ads_this_hourly');

if(is_admin()){ // admin unit
  include_once 'ads_admin.php';
  return;
}

// public site  block
include_once 'ads_filters.php';
include_once 'all_inclusive.php';
include_once 'ads_function.php';


// Check is_page ?
add_action('wp', 'ads_wp');
function ads_wp(){
    global $ads_options;
    if(is_page()){
        add_filter('the_content','ads_the_content');
       	ob_start();
    }else{
         /* перенаправляет ссылки редактировать запись на редактор плагина */
        if($ads_options['ads_edit_page'])
            add_filter('get_edit_post_link','ads_get_edit_post_link',1,3);

        /* применять шаблоны постов */
        if($ads_options['ads_template_apply']){
          add_filter('the_content', 'ads_template_apply',100);
        }

        /* auto more */
        if($ads_options['ads_auto_more']
            and (is_category() OR is_author() OR  is_archive() OR  is_search() )
            )
            add_filter('the_posts', 'ads_auto_more', 1);

        /* add post id for title */
        if($ads_options['ads_id_title'])
            add_filter('the_title', 'ads_id_title');
    }
}

// search tag <!--AdsForm--> <!--AdsFormEdit--> <!--AdsFormPay-->
function ads_the_content($content){
    if(preg_match('~<!--AdsForm([\w]+)?-->~i',$content,$match)){
        session_start();
        include_once 'ads_form_class.php';
        include_once 'ads_form.php';

        // проверка полей фильтр по умолчанию
        add_filter('ads_check_fields', 'ads_default_filter');

        $ads_form = new Ads_Form_Handler;
        $res =  $ads_form->ads_main($content);
        return  $res;
    }else{
        return  $content;
    }
}


/*  для предварительного просмотра изменяет статус на publish
    если  если в сесии ads есть эта запись */
add_filter('posts_results', 'ads_prevew');

/*Apply the accelerator All Inclusive http://wordpress.org/extend/plugins/all-inclusive/ */   
if($ads_options['ads_all_inclusive']){
  add_filter('posts_results', 'all_inclusive');
}

/* поиск по полям ads_  и adp_   полям */
if( $ads_options['ads_queryfilter'] ){
    add_filter('request', 'ads_wp_request');
    add_filter('posts_request', 'ads_queryfilter');
}

/*исключаем рубрику ads_location везде получить выборку по ней можно только если
указать  ее  в child_of*/
if($ads_options['ads_location_root'])
    add_filter('list_terms_exclusions', 'ads_location_root', 10, 2);

/* notification comments */
if($ads_options['ads_comments_ping'])
    add_action('comment_post', 'ads_send_email');





