<?php
/*
функция обрезает полны текст по словам - создает анонс статтьи
$st - исходный текст, $len - кол-во символов,
$text_link - текст ссылки типа читать далее если текста нет ссылка не возвращается
только чистый текст
*/
function ads_more($st,$len,$text_link = ''){

   $st = strip_tags( trim($st) );
   if(utf8_strlen($st)<=$len) return trim($st);
   $st = str_replace('<!--more-->','',$st);
   $arr = preg_split('~([\s\,\.\?\!\;\-]+)~u', $st,-1,PREG_SPLIT_DELIM_CAPTURE);
   $st = '';
   foreach ($arr as $key=>$value) {
      if(utf8_strlen($st.$value)<$len )
        $st .= $value;
      else{
          if($text_link){
              global $post_ID;
              return $st.'<a href="'.get_permalink().'">'.$text_link.'</a>';
          }
          else
             return $st;
      }
   }
   return trim($st);
}

function utf8_strlen($s) {
    $c = strlen($s); $l = 0;
    for ($i = 0; $i < $c; ++$i) if ((ord($s[$i]) & 0xC0) != 0x80) ++$l;
    return $l;
}

/*
выводит картинки для объявления работает быстрее чем альтернативный тег
[gallery]
*/
function ads_gallery($attachments, $attr = ''){
    global $post;
    static $style_include;
    if (sizeof($attachments) == 0) return false;
   	extract(shortcode_atts(array(
		'order'      => 'ASC',
		'orderby'    => 'menu_order ID',
		'id'         => $post->ID,
		'itemtag'    => 'dl',
		'icontag'    => 'dt',
		'captiontag' => 'dd',
		'columns'    => 3,
		'size'       => 'thumbnail',
        'start'      => 0,
        'count'      => 0,
        'link_img'   =>  1
	), $attr));


    $itemtag = tag_escape($itemtag);
	$captiontag = tag_escape($captiontag);
	$columns = intval($columns);
	$itemwidth = $columns > 0 ? floor(100/$columns) : 100;
    $i = 0;
	$selector = "gallery-ads";
    if(is_single()){
    	$output = apply_filters('gallery_style', "
    		<style type='text/css'>
    			#{$selector} {
    				margin: auto;
    			}
    			#{$selector} .gallery-item {
    				float: left;
    				margin-top: 10px;
    				text-align: center;
    				width: {$itemwidth}%;			}
    			#{$selector} img {
    				border: 2px solid #cfcfcf;
    			}
    			#{$selector} .gallery-caption {
    				margin-left: 0;
    			}
    		</style>
    		<div id='$selector' class='gallery galleryid-{$id}'>");
    }else{
    	$output = "<div id='$selector' class='gallery galleryid-{$id}'>";
    };
	$s = ($start)? $start: 0;
    $end = ($count) ? ($s+$count) : sizeof($attachments);
	for ( $s; $s<$end; $s++ ) {
        $attachment =  $attachments[$s];
	    if(!$attachment) continue;
        if($size == 'full') {
            if($attachment->full) $src = $attachment->full;
            elseif($attachment->imgUrl)$src = $attachment->imgUrl;
        }
        elseif($size == 'medium'){
            if($attachment->medium) $src =  $attachment->medium;
            elseif($attachment->thumbnail) $src = $attachment->thumbnail;
            elseif($attachment->mediumUrl) $src = $attachment->mediumUrl;
            elseif($attachment->thumbUrl) $src = $attachment->thumbUrl;
            else   $src = $attachment->full;

        }
        else {
            if($attachment->thumbnail) $src = $attachment->thumbnail;
            elseif($attachment->thumbUrl) $src = $attachment->thumbUrl;
        }
        if( preg_match('~image/~', $attachment->post_mime_type) )
            $full = ($attachment->full)?$attachment->full:$attachment->imgUrl;
        else
           $full  = ($attachment->attachment_url)?$attachment->attachment_url:$attachment->guid;

        if($link_img)
            $link = '<a href="'.$full.'" rel="lightbox" ><img src="'.$src.'" class="attachment-'.$size.' attachment" alt="" title="" /></a>';
        else
            $link = '<img src="'.$src.'" class="attachment-'.$size.' attachment" alt="" title="" />';


		$output .= "<{$itemtag} class='gallery-item' id='ads_gallery_$s'>";
		$output .= "
			<{$icontag} class='gallery-icon'>
				$link
			</{$icontag}>";
		if ( $captiontag && trim($attachment->name) ) {
			$output .= "
				<{$captiontag} class='gallery-caption'>
				" . wptexturize($attachment->name) . "
				</{$captiontag}>";
		}
		$output .= "</{$itemtag}>";
		if ( $columns > 0 && ++$i % $columns == 0 )
			$output .= '<br style="clear: both" />';
	}

	$output .= "
			<br style='clear: both;' />
		</div>\n";
   return $output;
}

function ads_recent($args){
    global $ads_options, $wpdb, $wp_query, $wp_object_cache;
    $cache_key = 'ads_recent_'.md5( serialize($args) );
    if ( $output = wp_cache_get($cache_key, 'ads') ) return $output;

    $defaults  = array(
        'meta_key'=>'ads_basecat',  'numberposts' => 5, 'post_type' => 'post',
        'post_status' => 'publish', 'image' => true, 'category' => 0,
        'rand' => 0, 'num_image' => 0
    );

    $r = wp_parse_args( $args, $defaults );

    extract($r);
    if($category){
        $arr_cat =  ( is_array($category) ) ? $category : array($category);
        $category = "'".implode("', '", $arr_cat)."'";
    }

    $select = "SELECT $wpdb->posts.* ";
	$from = "FROM $wpdb->posts ";
	$where = "WHERE 1=1 AND $wpdb->posts.post_type = '$post_type' AND $wpdb->posts.post_status = '$post_status' ";

	$group = "GROUP BY $wpdb->posts.ID";
    if($rand)
        $otder = "ORDER BY RAND()";
    else
	    $otder = "ORDER BY $wpdb->posts.post_date DESC";

	$limit = "LIMIT 0, $numberposts";

    if($category){
        $from .= "\nINNER JOIN $wpdb->term_relationships ON ($wpdb->posts.ID = $wpdb->term_relationships.object_id)"
                ."\nINNER JOIN $wpdb->term_taxonomy ON ($wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id)";
        $where .= "\nAND $wpdb->term_taxonomy.taxonomy = 'category'"
                  ."\nAND $wpdb->term_taxonomy.term_id IN ($category)";
    }

    if($meta_key){
        $select .= ", $wpdb->postmeta.meta_value  AS meta";
        $from .= "\nINNER JOIN $wpdb->postmeta ON ($wpdb->posts.ID =  $wpdb->postmeta.post_id)";
        $where .= "\nAND $wpdb->postmeta.meta_key = '$meta_key'";
    }


	if($image){
        $select .= ", image.ID  AS image";
        $from .= "\nINNER JOIN $wpdb->posts image ON ($wpdb->posts.ID = image.post_parent)";
        $where .= "\nAND image.menu_order = $num_image AND image.post_mime_type like 'image%' ";
    }

	$query = $select."\n".$from."\n".$where."\n".$group."\n".$otder."\n".$limit;

	$my_wpdb = new wpdb (DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
	$res = $my_wpdb->get_results($query);
	wp_cache_add($cache_key, $res, 'ads');
    return $res;
}


/*
функция печатает Дерево Городов  из категории ads_location
в 2 вариантах dropdown  выпадающий список для формы
либо просто ссылки list
*/
function ads_location($type='list'){
  global $ads_options;
  $ads_location = $ads_options['ads_location_root'];
  switch ($type) {
    case 'dropdown':
        $location = wp_dropdown_categories(array('child_of' => $ads_location,
                                            'hide_empty' => 0, 'hierarchical' => 1,
                                            'name'=>'ads_location','echo'=>0));
        $location = preg_replace('~<select[^>]+>~','\0<option class="level-0"  value="">-----</option>',$location);
        return $location;
    break;
    default:
    case 'list':
        $location = wp_list_categories(  array('child_of' => $ads_location,
                                            'hide_empty' => 0, 'hierarchical' => 1,
                                            'echo'=>0,  'title_li'=>'')   );

        return $location;
    break;
   }
}

function ads_get_links_post(){
    $url =  get_permalink();
    $title = get_the_title();
?>
<table id="post_links">
    <tr><th>URL:</th><td><input  type="text" value='<?=$url?>' /></td></tr>
    <tr><th>HTML Link:</th><td><input type="text" value='<a href="<?=$url?>"><?=$title?></a>' /></td></tr>
    <tr><th>bbCode:</th><td><input type="text" value="[url=<?=$url?>]<?=$title?>[/url]" /></td></tr>
</table>
<?
}


if ( ! function_exists ( 'mime_content_type' ) )
{
   function mime_content_type ( $f )
   {
       return trim ( exec ('file -bi ' . escapeshellarg ( $f ) ) ) ;
   }
}

// collects an array like $ _Get in the url string
function append_params($array, $parent='')
{
    $params = array();
    foreach ($array as $k => $v)
    {
        if (is_array($v))
            $params[] = append_params($v, (empty($parent) ? urlencode($k) : $parent . '[' . urlencode($k) . ']'));
        else
            $params[] = (!empty($parent) ? $parent . '[' . urlencode($k) . ']' : urlencode($k)) . '=' . urlencode($v);
    }

    $sessid = session_id();
    if (!empty($parent) || empty($sessid))
        return implode('&amp;', $params);

    // Append the session ID to the query string if we have to.
    $sessname = session_name();
    if (ini_get('session.use_cookies'))
    {
        if (!ini_get('session.use_only_cookies') && (!isset($_COOKIE[$sessname]) || ($_COOKIE[$sessname] != $sessid)))
            $params[] = $sessname . '=' . urlencode($sessid);
    }
    elseif (!ini_get('session.use_only_cookies'))
        $params[] = $sessname . '=' . urlencode($sessid);

    return implode('&amp;', $params);
}